DROP TABLE IF EXISTS `seis_new_net`.`ew_params_pick`;
CREATE TABLE `seis_new_net`.`ew_params_pick` (
  `hostname` varchar(80) default NULL COMMENT 'Host running the EW Module',
  `modname` varchar(80) default NULL COMMENT 'ModName',
  `fk_channel_52` bigint(20) NOT NULL COMMENT 'Link: fk to channel_52',
  `revision` bigint(20) NOT NULL default '0' COMMENT 'Revision number for channel',
  `pick_flag` int(11) default NULL COMMENT '0, ew_params_pick will not try to pick P-wave arrivals, 1 yes',
  `pin_numb` bigint(20) default NULL COMMENT 'this field is not used by ew_params_pick, but exists for posterity',
  `itr1` bigint(20) default NULL COMMENT '(i5) used to calculate the zero-crossing termination count',
  `minsmallzc` bigint(20) default NULL COMMENT '(i6) Defines minimum number of zero-crossings for valid pick',
  `minbigzc` bigint(20) default NULL COMMENT '(i7) Defines min number "big zero-crossings" for valid pick',
  `minpeaksize` bigint(20) default NULL COMMENT '(i8) Defines min amplitude (digital counts) for a valid pick',
  `maxmint` bigint(20) default NULL COMMENT 'Maximum interval (in samples) between zero crossings',
  `i9` bigint(20) default NULL COMMENT 'Defines the minimum coda length (seconds) for a valid pick',
  `rawdatafilt` double default NULL COMMENT '(c1) Sets filter parameter RawDataFilt applied to raw trace',
  `charfuncfilt` double default NULL COMMENT '(c2) Sets filter parameter CharFuncFilt characteristic fun.',
  `stafilt` double default NULL COMMENT '(c3) Sets filter parameter (time constant) StaFilt (STA)',
  `ltafilt` double default NULL COMMENT '(c4) Sets filter parameter (time constant) LtaFilt (LTA)',
  `eventthresh` double default NULL COMMENT '(c5) Sets STA/LTA event threshold',
  `rmavfilt` double default NULL COMMENT 'Filter parameter (time constant)running mean of the absolute',
  `deadsta` double default NULL COMMENT '(c6) Sets the dead station threshold (counts).',
  `codaterm` double default NULL COMMENT '(c7) Sets the "normal" coda termination threshold (counts).',
  `altcoda` double default NULL COMMENT '(c8) Defines "noisy station level"',
  `preevent` double default NULL COMMENT '(c9) Defines alternate coda termination thresh for noisy sta',
  `erefs` double default NULL COMMENT 'Used calculating the increment (crtinc) to be added to ecrit',
  `clipcount` bigint(20) default NULL COMMENT 'Specifies maximum absolute amplitude, in counts zero-to-peak',
  `modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`fk_channel_52`,`revision`,hostname,modname),
  CONSTRAINT `ew_params_pick_ibfk_1` FOREIGN KEY (`fk_channel_52`) REFERENCES `channel_52` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Configuration EarthWorm module pick_ew';


