
#
#   THIS FILE IS UNDER RCS - DO NOT MODIFY UNLESS YOU HAVE
#   CHECKED IT OUT USING THE COMMAND CHECKOUT.
#
#    $Id: makefile.sol 3231 2007-12-31 19:12:07Z paulf $
#
#    Revision history:
#     $Log$
#     Revision 1.4  2007/12/31 19:12:07  paulf
#     solaris sqlite changes
#
#     Revision 1.3  2004/03/17 20:41:28  davidk
#     Added support for Purify during link.
#
#     Revision 1.2  2000/08/08 17:19:17  lucky
#     Added lint directive
#
#     Revision 1.1  2000/02/14 19:58:27  lucky
#     Initial revision
#
#
#



CFLAGS = -D_REENTRANT $(GLOBALFLAGS)

B = $(EW_HOME)/$(EW_VERSION)/bin
L = $(EW_HOME)/$(EW_VERSION)/lib


BINARIES = wave_serverV.o index.o server_thread.o serve_trace.o index_util.o \
         compare.o tb_packet_db.o $L/sqlite3.o $L/dirops_ew.o $L/getutil.o\
	 $L/kom.o $L/logit_mt.o $L/sema_ew.o $L/sleep_ew.o $L/socket_ew.o\
	 $L/socket_ew_common.o $L/swap.o  $L/threads_ew.o $L/time_ew.o\
	 $L/transport.o $L/mem_circ_queue.o 

ALL: wave_serverV tools

wave_serverV: $(BINARIES)
	$(PURIFY_DK) cc -g -o $B/wave_serverV $(BINARIES) -lm -lnsl -lsocket -mt -lposix4 -lthread -lc -ldl

.c.o:
	$(CC) $(CFLAGS) -g $(CPPFLAGS) -c  $(OUTPUT_OPTION) $<

tools: 
	(cd Tools; make -f makefile.sol)


lint:
	lint wave_serverV.c index.c server_thread.c serve_trace.c index_util.c compare.c  $(GLOBALFLAGS)



# Clean-up rules
clean:
	rm -f a.out core *.o *.obj *% *~
	(cd Tools; make -f makefile.sol clean)

clean_bin:
	rm -f $B/wave_serverV*
	(cd Tools; make -f makefile.sol clean_bin)
